/*
polaros2.cmd - create OS/2 program objects on desktop for Polarbar Mailer
Copyright 2000-2004, Charles H. McKinnis
Changes - 4 Feb 2004
   Allow Java 1.1.8 to be used even if it is not the default JVM.
   Allow Java 1.4.x to be used.
Changes - 8 Jul 2003
   Set BEGINLIBPATH for Java
   Handle Innotek OS2 Java 1.4.2, drop 1.4.1 support
Changes - 19 Jun 2003
   Allow for options to be passed to the polarbar execution
   Allow running from LAN drive
   Generate security parms as required
   Handle Innotek OS2 Java 1.4.1
   Look for Java 1.3+ info in os2.ini
Changes - 27 Jan 2003
	Make Java storage limitation optional
	Build polarbar.cmd file dynamically
	Be sensitive to Java version
	Remove Hot Java Browser support
	Correct disabling of JIT compiler
	Attempt to update PolarBar Mailer object before creating a new one
	Update polarbar.cmd to eliminate 2 windows for execution
*/

Trace('N')
java_runtime = ''
our_cmd = 'POLARBAR.CMD'
our_jar = ''
our_opts = ''

Call Rxfuncadd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

Parse Source . . polar_os2 .
our_path = Filespec('d', polar_os2)||Filespec('p', polar_os2)
If Length(our_path) > 3 Then
   our_dir = Strip(our_path, 't', '\')
Else
   our_dir = our_path
Call Directory our_dir
our_cmd = our_dir||'\'||our_cmd

Say 'POLAROS2 1.3 - Copyright 2000-2004, Charles H. McKinnis'
Say 'Do you wish to install a Polarbar Mailer object (y,N)?'
Pull ans .
If \Abbrev(ans, 'Y') Then
   Call Exit

file_sys = SysFileSystemType(Filespec('d', our_cmd))
If Wordpos(file_sys, 'HPFS JFS LAN FAT') <> 0 Then
   Say 'Found' our_dir 'on an' file_sys 'drive'
Else
   Do
      Say appl 'needs to run from an HPFS, JFS, LAN, or FAT drive'
      Say 'Found' our_dir 'on a' file_sys 'drive'
      Call Exit
   End
boot_drive = SysBootDrive()

java_list. = ''
java_list.0 = 0
t_java_path = Value('path', ,'os2environment')
frc = Value('t_java_path', t_java_path, 'os2environment')
java_name = SysSearchPath('t_java_path', 'JAVA.EXE')
If java_name = '' Then
   Do
      Say 'Enter the full path to JAVA.EXE'
      Parse Pull java_name
      java_name = Strip(java_name, , '\')||'\'||'JAVA.EXE'
      xrc = SysFileTree(java_name, 'temp.', 'FSO')
      If xrc = 0 & temp.0 > 0 Then
         java_name = temp.1
      Else
         java_name = ''
   End

If java_name <> '' Then Do x = 1 While java_name <> ''
   Do Queued()
      Parse Pull .
   End
   Address cmd '@'||java_name '-version 2>&1|RXQUEUE'
   Do Queued()
      Parse Pull ans
      If Abbrev(Translate(ans), 'JAVA VERSION') | Abbrev(Translate(ans), 'JAVA.EXE') Then Do
         Parse Value Strip(ans) With . . java_lvl .
         Leave
      End
   End
   Do Queued()
      Parse Pull ans
   End
   java_lvl = Left(Strip(java_lvl, , '"'), 5)
   If java_lvl >= '1.1.4' Then Do
      If x = 1 Then Say 'OS/2 Java' java_lvl 'detected (default).'
      Else Say 'OS/2 Java' java_lvl 'detected.'
      Call SysStemInsert 'java_list.', java_list.0 + 1, 'OS/2 Java' java_lvl java_name
      /* check for Java 1.3 */
      If java_lvl = '1.3.1' Then Do
         java_home = Strip(SysIni('user', 'Java131', 'USER_HOME'), 't', '00'x)
         If java_home <> 'ERROR:' Then Do
            If java_lvl <> '1.3.1' Then Do
               If SysFileTree(java_home||'\java.exe', 'temp.', 'fso') = 0 Then Do
                  If temp.0 <> 0 Then Do
                     java_name = temp.1
                     Call SysStemInsert 'java_list.', java_list.0 + 1, 'OS/2 Java 1.3.1' java_name
                  End
               End
            End
         End
      End
   End
   java_dir = Strip(Filespec('d', java_name)||Filespec('p', java_name),,'\')
   If Pos(java_dir, t_java_path) <> 0 Then Do
      t_java_path = Substr(t_java_path, Pos(java_dir, t_java_path) + Length(java_dir))
      frc = Value('t_java_path', t_java_path, 'os2environment')
      java_name = SysSearchPath('t_java_path', 'JAVA.EXE')
   End
   Else
      java_name = ''
End
Else Do
   Say 'Could not locate JAVA.EXE in your system'
   Call Exit
End
If java_list.0 = 0 Then Do
   Say 'You must be at Java level 1.1.4 or above'
   Call Exit
End
/* check for Java 1.4 */
java_lvl = Strip(SysIni('user', 'OS2 Kit for Java', 'CurrentVersion'), 't', '00'x)
If java_lvl <> 'ERROR:' Then Do
   java_home = Strip(SysIni('user', 'OS2 Kit for Java', java_lvl), 't', '00'x)
   If java_home <> 'ERROR:' Then Do
      If SysFileTree(java_home||'\java.exe', 'temp.', 'fso') = 0 Then Do
         If temp.0 <> 0 Then Do
            java_lvl = Left(Strip(java_lvl), 5)
            Say 'OS/2 Java' java_lvl 'detected.'
            java_name = temp.1
            Call SysStemInsert 'java_list.', java_list.0 + 1, 'OS/2 Java' java_lvl java_name
         End
      End
   End
End
If java_list.0 > 1 Then Do
   Say 'Please select the Java support for Polarbar, 1 -' java_list.0
   Do x = 1 To java_list.0
      Say x '-' java_list.x
   End
   Pull ans .
   If ans >= 1 & ans <= java_list.0 Then Do
      java_name = Word(java_list.ans, 4)
      java_lvl = Word(java_list.ans, 3)
   End
   Else Do
      Say 'No Java support was selected.  Exiting.'
      Call Exit
   End
End
Else Do
   java_name = Word(java_list.1, 4)
   java_lvl = Word(java_list.1, 3)
End

obj_icon = our_dir||'\pbmos2.ico'
obj_icon_pos = '45 45'
java_home = ''
java_classes = ''
java_libpath = ''
java_path = ''

java_root = Substr(java_name, 1, Pos('\', java_name, 4) - 1)
Select
   When java_lvl <= '1.1.8' Then Do
      java_classes = 'classes.zip'
      rc = SysFileTree(java_root||'\'||java_classes, 'class.', 'FSO')
      If rc = 0 & class.0 > 0 Then Do
         java_classes = class.1
         Say 'Using JAVA class -' java_classes
         java_runtime = 'JAVAPM.EXE'
      End
      Else Do
         Say 'No runtime java classes found under' java_root
         Call Exit
      End
   End
   Otherwise Do
      java_runtime = 'JAVAW.EXE'
   End
End
java_base = Left(Filespec('d', java_name)||Filespec('p', java_name), Pos('\', java_name, 4) - 1)
If SysFileTree(java_base||'\'||java_runtime, 'temp.', 'fso') = 0 Then Do
   If temp.0 <> 0 Then
      java_runtime = temp.1
   Else Do
      Say 'Unable to locate' java_runtime||'.'
      Call Exit
   End
End
Else Do
   Say 'Unable to locate' java_runtime||'.'
   Call Exit
End
Select
   When java_lvl <= '1.1.8' Then Do
      java_libpath = java_root||'\dll;'||java_root||'\bin;'
      java_path = java_root||'\bin;'
   End
   When java_lvl = '1.3.1' Then Do
      java_libpath = java_root||'\jre\bin;'||java_root||'\jre\dll;'
      java_path = java_root||'\bin;'
   End
   When java_lvl >= '1.4.1' Then Do
      java_libpath = java_root||'\bin;'||java_root||'\bin\client;'
      java_path = java_root||'\bin;'
   End
   Otherwise Do
      Say 'Java' java_lvl 'is not supported.'
      Call Exit
   End
End

config = Stream(SysBootDrive()||'\config.sys', 'c', 'query exists')
config_classpath = Value('CLASSPATH', , 'OS2ENVIRONMENT')
If config_classpath = '' Then
   Say 'Unable to locate SET CLASSPATH= in' config
Else Do
   If Lastpos(';', config_classpath) <> Length(config_classpath) Then
      config_classpath = config_classpath||';'
End

Call List_jar our_dir
If pclasses.0 > 0 Then Do
   Do i = 1 To pclasses.0
      If pclasses.i <> '' Then
         Say i '-' pclasses.i
   End
   Say 'Select the Polarbar Java class for this object, 1 -' pclasses.0
   Parse Pull ans .
   If 1 <= ans & ans <= pclasses.0 Then
      polar_class = Filespec('n', pclasses.ans)
   Else Do
      Say 'Invalid selection'
      Call Exit
   End
End
Else Do
   Say 'Could not locate any classes in -' our_dir
   Call Exit
End

Say 'Do you want to limit the storage available to Java (y/N)?'
Pull ans .
If Abbrev(ans, 'Y') Then Do
   If java_lvl > '1.1.8' Then
      java_opts = '-Xmx32m'
   Else
      java_opts = '-mx32m'
End
Else
   java_opts = ''

Say 'Do you want to use the alternate icons (y/N)?'
Parse Upper Pull ans .
If Abbrev(ans, 'Y') Then
   alt_icons = 1
Else
   alt_icons = 0

If Pos(Translate(polar_class), Translate(config_classpath)) = 0 Then Do
   If alt_icons Then
      our_jar = Space(our_jar||'.;')
   our_jar = Space(our_jar||polar_class||';')
   Say 'Setting classpath -' our_jar
End
Else
   Say 'Found' polar_class 'in' config 'CLASSPATH'

Do i = 1 To Words(java_classes)
   If Pos(Translate(Word(java_classes, i)), Translate(config_classpath)) = 0 Then Do
      our_jar = Space(our_jar||Word(java_classes, i)||';')
      Say 'Setting classpath -' our_jar
   End
   Else
      Say 'Found' Word(java_classes, i) 'in' config 'CLASSPATH'
End

Say 'Do you want to disable the Just In Time compiler (y,N)?'
Parse Upper Pull answer .
If Abbrev(answer, 'Y') Then
   java_opts = java_opts '-Djava.compiler=none'

obj_class = 'WPProgram'
obj_title = 'Polarbar^Mailer'
obj_loc = '<WP_DESKTOP>'
obj_id = 'OBJECTID=<POLARBAR_MAILER>;'
exec = 'EXENAME='||our_cmd||';'
window = 'CCVIEW=NO;'

Say 'Do you want to run with the Java console window minimized (Y,n)?'
Parse Upper Pull answer .
If Abbrev(answer, 'N') Then
   window = window||'MINIMIZED=NO;'
Else
   window = window||'MINIMIZED=YES;'

Say 'Do you want to close the Java console window when Polarbar ends (Y,n)?'
Parse Upper Pull answer .
If Abbrev(answer, 'N') Then
   window = window||'NOAUTOCLOSE=YES;'
Else
   window = window||'NOAUTOCLOSE=NO;'
icon = 'ICONFILE='||obj_icon||';ICONPOS='||obj_icon_pos||';'
our_polarbar = 'org.polarbar.mailer'

If java_lvl <= '1.1.8' Then Do
   /* build a polarbar classpath */
   java_classpath = ''
   rest = config_classpath
   Do Until rest = ''
      Parse Var rest class ';' rest
      class = Strip(class)||';'
      If Pos(':\JAVA', Translate(class)) <> 0 | class = '.\' Then
         java_classpath = java_classpath||class
   End
   our_classpath = our_jar||Strip(java_classpath)
End
Else
   our_classpath = our_jar

semi = Pos(';', our_classpath)
Do While semi <> 0
   our_classpath = Substr(our_classpath, 1, semi - 1)||'^'||Substr(our_classpath, semi)
   If semi + 2 > Length(our_classpath) Then
      Leave
   semi = Pos(';', our_classpath, semi + 2)
End

/* check for security options */
If java_lvl > '1.1.8' Then Do
   java_policy = our_dir||'\java.policy'
   java_opts = java_opts '-Djava.security.manager -Djava.security.policy==file://'||java_policy
   Say 'Java' java_lvl 'requires a security policy to operate correctly.'
   Say 'Creating a default policy file as' our_dir||'\java.policy.'
   Call SysFileDelete java_policy
   Call Stream java_policy, 'c', 'open write'
   Call Lineout java_policy, 'grant {'
   Call Lineout java_policy, '	permission java.security.AllPermission;'
   Call Lineout java_policy, '};'
   Call Stream java_policy, 'c', 'close'
End
java_opts = Space(java_opts '-classpath' our_classpath)

setup = obj_id||exec||window||icon
If SysCreateObject(obj_class, obj_title, obj_loc, setup, 'U') Then Do
   Say 'Polarbar program object created'
   Call Build_polarbar_cmd
   Say our_cmd 'created'
End
Else
   Say 'Failed to create or update Polarbar program object'
Call Exit

Exit: Procedure
Exit
Return

List_jar: Procedure Expose pclasses.
Parse Arg path
pclasses. = ''
pclasses.0 = 0
xrc = SysFileTree(path||'\*.zip', 'pclasses.', 'FO')
xrc = SysFileTree(path||'\*.jar', 'temp.', 'FO')
If xrc = 0 & temp.0 <> 0 Then
   Call SysStemCopy 'temp.', 'pclasses.', , pclasses.0 + 1
x = 1
Do Forever
   If x > pclasses.0 Then
      Leave
   If Abbrev(Translate(Filespec('n', pclasses.x)), 'HOTJAVA') Then Do
      Call SysStemDelete 'pclasses.', x, 1
      Iterate
   End
   x = x + 1
End
Return

Build_polarbar_cmd:
x. = ''
x.0 = 0
Call SysStemInsert 'x.', x.0 + 1, "/* OS/2 PolarBar startup */"
Call SysStemInsert 'x.', x.0 + 1, "Trace 'N'"
Call SysStemInsert 'x.', x.0 + 1, "Parse Arg run_opts"
Call SysStemInsert 'x.', x.0 + 1, "run_opts = Space(run_opts)"
Call SysStemInsert 'x.', x.0 + 1, "Parse Source . . our_cmd ."
Call SysStemInsert 'x.', x.0 + 1, "our_path = Filespec('d', our_cmd)||Filespec('p', our_cmd)"
Call SysStemInsert 'x.', x.0 + 1, "If Length(our_path) > 3 Then our_dir = Strip(our_path, 't', '\')"
Call SysStemInsert 'x.', x.0 + 1, "Else our_dir = our_path"
Call SysStemInsert 'x.', x.0 + 1, "Call Directory our_dir"
Call SysStemInsert 'x.', x.0 + 1, "save_libpath = Value('BEGINLIBPATH', , 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "ans = Value('BEGINLIBPATH', '"||java_libpath||"'||save_libpath, 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "save_path = Value('PATH', , 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "ans = Value('PATH', '"||java_path||"'||save_path, 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "Address cmd '"||Space(java_runtime java_opts our_polarbar our_opts)||"' run_opts"
Call SysStemInsert 'x.', x.0 + 1, "ans = Value('BEGINLIBPATH', save_libpath, 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "ans = Value('PATH', save_path, 'OS2ENVIRONMENT')"
Call SysStemInsert 'x.', x.0 + 1, "Return"
Call SysStemInsert 'x.', x.0 + 1, '0D0A'x
Call SysFileDelete our_cmd
Call Stream our_cmd, 'c', 'open write'
Do x = 1 To x.0
   Call Lineout our_cmd, x.x
End
Call Stream our_cmd, 'c', 'close'
Return
